Page MenuHomePhabricator

[Bug] Mobile watchlist automatically redirecting to "view and edit"
Closed, ResolvedPublic

Description

Steps to reproduce

Make sure you are using a new account which has made no edits.

  1. Log in to the mobile site and visit watchlist on wikivoyage with AMC off\
  2. Select "view relevant changes"

Expected results

  • Watchlist goes to the appropriate tab

Actual results

  • Watchlist redirects back to "view and edit watchlist"

Check any additional observations

From T362297#9707316:

On my local, I can see that the redirect from Special:Watchlist to Special:EditWatchlist only happens for non-admin users.
admin users are still able to visit Special:Watchlist.

QA steps

Create a new account and visit mobile

  • Click hamburger and click watchlist
  • You are navigated to Special:EditWatchlist

Create an account which has made at least 1 edit.

  • Click hamburger and click watchlist
  • You are navigated to Special:Watchlist

Sign off steps

  • Consider creating a new ticket to add both "Saved" and "Watchlist" to user menu to separate the bookmarking and watchlist functionality.

Event Timeline

ovasileva triaged this task as Unbreak Now! priority.Apr 11 2024, 3:26 PM
ovasileva lowered the priority of this task from Unbreak Now! to High.Apr 11 2024, 5:03 PM

Okay, we tracked this one down and the impact is actually very narrow (only people with no edits viewing the watchlist). As the threshold is < 10 edits, we should still fix this, but no longer a train blocker. cc @hashar

Oh that is nice, I guess I should edit Wikivoyage a bit more to be exempt from the bug. Thank you for the triage!

ovasileva lowered the priority of this task from High to Medium.Apr 12 2024, 6:40 AM

Just sharing what we've learned so far. It turns out this behaviour is somewhat intentional and has been implemented by design as a solution to T88270.
Basically the behaviour (as implemented) checks the users edit count, and if it is less than 10, redirects them from Special:Watchlist to Special:EditWatchlist. (thank you @SToyofuku-WMF for tracking down this codepath!).

Although this achieves the goals of the task, it basically prevents anyone with less than 10 edits from viewing the watchlist.

Instead, the behaviour should really be: if a user has less than 10 edits, change the watchlist link in the sidebar menu from Special:Watchlist to Special:EditWatchlist.

The redirect should be removed and according to https://phabricator.wikimedia.org/T88270#3348632 it seems like there's a rationale for changing the edit-count ( $wgMFwatchlistEditCountThreshold) from 10 to 1 while we're at it.

A quick note about another thing we found when investigating this: to go directly to the view watchlist page you can go to https://en.m.wikivoyage.org/wiki/Special:Watchlist?watchlistview=feed to avoid a redirect. We are still discussing specific next steps but the above should work in any case.

Change #1020388 had a related patch set uploaded (by Jdlrobson; author: Jdlrobson):

[mediawiki/extensions/MobileFrontend@master] Drop Watchlist redirect logic

https://gerrit.wikimedia.org/r/1020388

Change #1020389 had a related patch set uploaded (by Jdlrobson; author: Jdlrobson):

[mediawiki/skins/MinervaNeue@master] Main menu should link to EditWatchlist by default for users that haven't edited

https://gerrit.wikimedia.org/r/1020389

@ovasileva @JScherer-WMF the current situation isn't great IMO. I've submitted 2 patches to improve the status quo so that the logic lives in the rendering of the main menu in Minerva instead of based on the URL.

After that, I would recommend adding two links: To the watchlist and the reading list (which could link to https://www.mediawiki.org/wiki/Special:ReadingLists/Jdlrobson/-10) to cater for both audiences - editors who want to see the watchlist and editors who want to manage a reading list - what do you think?

Screenshot 2024-04-16 at 4.06.51 PM.png (1×1 px, 146 KB)

Screenshot 2024-04-16 at 4.00.20 PM.png (1×2 px, 230 KB)

For now, we can limit display of reading lists just to the watchlist but in future we could expand this similar to apps.
This would be consistent with apps which link to both.
The reading list feature also has the benefit of being more modern in relation to the design system (uses Codex)

Change #1020389 merged by jenkins-bot:

[mediawiki/skins/MinervaNeue@master] Main menu should link to EditWatchlist by default for users that haven't edited

https://gerrit.wikimedia.org/r/1020389

Change #1020388 merged by jenkins-bot:

[mediawiki/extensions/MobileFrontend@master] Drop Watchlist redirect logic

https://gerrit.wikimedia.org/r/1020388

@ovasileva this is fixed now. I asked @JScherer-WMF about linking to both "Saved" and "Watchlist" and separating these features and linking to both and he was in support.
What do you think? T363032

@ovasileva this is fixed now. I asked @JScherer-WMF about linking to both "Saved" and "Watchlist" and separating these features and linking to both and he was in support.
What do you think? Should we create a follow up ticket?
Full context: https://phabricator.wikimedia.org/T362338#9720869

@Jdlrobson - what behavior does the fix have? Could you document it in the task description?

@ovasileva created QA steps. If you want to confirm the follow up ticket, we can move this into QA if you want?

I've created T363032 to handle the proposed follow up work.

Got it. Can confirm new threshold works as expected. Let's continue discussion in T363032: Mobile should separate out Saved reading list and editor Watchlist experiences. on the general solution

@Jdlrobson I did not set this tested in beta. Also, is this testable for QA since we try not to create new users for testing purposes in PROD?

@GMikesell-WMF you can skip QA on this one. I've just verified it is working in production by using a wiki I have never edited
https://az.m.wikipedia.org/wiki/X%C3%BCsusi:%C4%B0zl%C9%99m%C9%99Siyah%C4%B1s%C4%B1n%C4%B1Redakt%C9%99Et

It defaults to editwatchlist:

Screenshot 2024-04-30 at 3.29.33 PM.png (813×1 px, 126 KB)

And i can click the tab to view the standard Watchlist.